%global homedir %{_datadir}/%{name}
%global confdir config

%if "%{?scl}" == "ruby193"
    %global scl_prefix %{scl}-
    %global scl_ruby /usr/bin/ruby193-ruby
    %global scl_rake /usr/bin/ruby193-rake
%else
    %global scl_ruby /usr/bin/ruby
    %global scl_rake /usr/bin/rake
%endif

# set and uncomment all three to set alpha tag
#global alphatag RC2
#global dotalphatag .%{alphatag}
#global dashalphatag -%{alphatag}

Name:           foreman-proxy
Version:        1.7.2.5
Release:        1%{?dotalphatag}%{?dist}
Summary:        Restful Proxy for DNS, DHCP, TFTP, PuppetCA and Puppet

Group:          Applications/System
License:        GPLv3+
URL:            http://theforeman.org/projects/smart-proxy
Source0:        http://downloads.theforeman.org/%{name}/%{name}-%{version}%{?dashalphatag}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  /usr/bin/rename
BuildRequires:  asciidoc
BuildRequires:  %{?scl_prefix}rubygem(rake) >= 0.8.3

%if "%{?scl}" == "ruby193" || (0%{?rhel} == 6 && "%{?scl}" == "")
BuildRequires: %{?scl_prefix}ruby(abi)
Requires:      %{?scl_prefix}ruby(abi)
%else
BuildRequires: %{?scl_prefix}ruby(release)
Requires:      %{?scl_prefix}ruby(release)
%endif
Requires:       foreman-debug
Requires:       %{?scl_prefix}rubygems
Requires:       %{?scl_prefix}rubygem(smart_proxy_discovery)
Requires:       %{?scl_prefix}rubygem(rake) >= 0.8.3
Requires:       %{?scl_prefix}rubygem(sinatra)
Requires:       %{?scl_prefix}rubygem(rack) >= 1.1.0
Requires:       %{?scl_prefix}rubygem(json)
Requires:       %{?scl_prefix}rubygem(rkerberos)
Requires:       %{?scl_prefix}rubygem(rubyipmi)
Requires:       %{?scl_prefix}rubygem(gssapi)
Requires:       %{?scl_prefix}rubygem(bundler_ext)
Requires:       sudo
Requires:       wget
Requires(pre):  shadow-utils
%if 0%{?rhel} == 6
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts
%else
Requires(post): systemd-sysv
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
BuildRequires: systemd-units
%endif


%description
Manages DNS, DHCP, TFTP and puppet settings though HTTP Restful API
Mainly used by the foreman project (http://theforeman.org)

%prep
%setup -q -n %{name}-%{version}%{?dashalphatag}

%build
#build man pages
%{scl_rake} -f Rakefile.dist build \
PREFIX=%{_prefix} \
SBINDIR=%{_sbindir} \
SYSCONFDIR=%{_sysconfdir} \
--trace

#replace shebangs for SCL
%if %{?scl:1}%{!?scl:0}
  for f in bin/smart-proxy extra/query.rb extra/changelog extra/migrate_settings.rb; do
    sed -ri '1sX(/usr/bin/ruby|/usr/bin/env ruby)X%{scl_ruby}X' $f
  done
  sed -ri '1,$sX/usr/bin/rubyX%{scl_ruby}X' extra/spec/foreman-proxy.init
%endif

#replace default location of 'settings.d'
sed -i '/^---/ a #replace default location of "settings.d"\n:settings_directory: %{_sysconfdir}/%{name}/settings.d\n' \
  %{confdir}/settings.yml.example

# switches to bundler_ext instead of bundler
mv Gemfile Gemfile.in

%install
rm -rf %{buildroot}
#install man pages
%{scl_rake} -f Rakefile.dist install \
PREFIX=%{buildroot}%{_prefix} \
SBINDIR=%{buildroot}%{_sbindir} \
SYSCONFDIR=%{buildroot}%{_sysconfdir} \
--trace
%{scl_rake} -f Rakefile.dist clean
# install foreman-devel script
install -Dp -m0755 extra/foreman-debug-proxy %{buildroot}%{_datadir}/foreman/script/foreman-debug.d/75-foreman-proxy

install -d -m0755 %{buildroot}%{_datadir}/%{name}
install -d -m0755 %{buildroot}%{_datadir}/%{name}/config
install -d -m0755 %{buildroot}%{_sysconfdir}/%{name}
install -d -m0755 %{buildroot}%{_sysconfdir}/%{name}/settings.d
install -d -m0755 %{buildroot}%{_localstatedir}/lib/%{name}
install -d -m0750 %{buildroot}%{_localstatedir}/log/%{name}
install -d -m0750 %{buildroot}%{_localstatedir}/lib/rpm-state/%{name}
install -d -m0750 %{buildroot}%{_var}/run/%{name}

%if 0%{?rhel} == 6
install -Dp -m0644 foreman-proxy.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -Dp -m0755 foreman-proxy.init %{buildroot}%{_initrddir}/%{name}
install -Dp -m0644 logrotate %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
%else
install -Dp -m0644 foreman-proxy.service %{buildroot}%{_unitdir}/%{name}.service
install -Dp -m0644 foreman-proxy.tmpfiles %{buildroot}%{_prefix}/lib/tmpfiles.d/%{name}.conf
install -Dp -m0644 logrotate.systemd %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
%endif

mkdir -p %{buildroot}%{_sbindir}
install -m 0755 sbin/foreman-prepare-realm %{buildroot}%{_sbindir}/foreman-prepare-realm
cp -p -r bin extra lib modules Rakefile Gemfile.in bundler.d config.ru VERSION %{buildroot}%{_datadir}/%{name}
chmod a+x %{buildroot}%{_datadir}/%{name}/bin/smart-proxy
rm -rf %{buildroot}%{_datadir}/%{name}/*.rb

# remove all test units from productive release
find %{buildroot}%{_datadir}/%{name} -type d -name "test" |xargs rm -rf

# Move config files to %{_sysconfdir}
install -Dp -m0644 %{confdir}/settings.yml.example %{buildroot}%{_sysconfdir}/%{name}/settings.yml
ln -sv %{_sysconfdir}/%{name}/settings.yml %{buildroot}%{_datadir}/%{name}/config/settings.yml
install -Dp -m0644 %{confdir}/settings.d/*.example %{buildroot}%{_sysconfdir}/%{name}/settings.d/
rename .example '' %{buildroot}%{_sysconfdir}/%{name}/settings.d/*

# Put HTML %{_localstatedir}/lib/%{name}/public
for x in public views; do
  cp -pr $x %{buildroot}%{_localstatedir}/lib/%{name}/
  ln -sv %{_localstatedir}/lib/%{name}/$x %{buildroot}%{_datadir}/%{name}/$x
done

# Put logs in %{_localstatedir}/log/%{name}
ln -sv %{_localstatedir}/log/%{name} %{buildroot}%{_datadir}/%{name}/logs

# Link temp directory to system wide temp
ln -sv %{_tmppath} %{buildroot}%{_datadir}/%{name}/tmp

%clean
rm -rf %{buildroot}

%files
%doc README LICENSE VERSION
%{_datadir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%attr(-,%{name},%{name}) %{_localstatedir}/lib/%{name}
%dir %attr(-,%{name},%{name}) %{_localstatedir}/lib/rpm-state/%{name}
%attr(-,%{name},%{name}) %{_localstatedir}/log/%{name}
%attr(-,%{name},%{name}) %{_var}/run/%{name}
%attr(-,%{name},root) %{_datadir}/%{name}/config.ru
%{_sbindir}/foreman-prepare-realm
%{_mandir}/man8
%if 0%{?rhel} == 6
%{_initrddir}/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%else
%{_unitdir}/%{name}.service
%{_prefix}/lib/tmpfiles.d/%{name}.conf
%endif
%{_datadir}/foreman/script/foreman-debug.d/75-foreman-proxy

%pre
# Add the "foreman-proxy" user and group
getent group foreman-proxy >/dev/null || \
  groupadd -r foreman-proxy
getent passwd foreman-proxy >/dev/null || \
  useradd -r -g foreman-proxy -d %{homedir} -s /sbin/nologin -c "Foreman Proxy deamon user" foreman-proxy

# Keep monolithic config in case it's replaced with the new default
if [ $1 == 2 -a ! -e %{_sysconfdir}/%{name}/settings.d ]; then
  test -e %{_localstatedir}/lib/rpm-state/%{name} || mkdir -p %{_localstatedir}/lib/rpm-state/%{name}
  cp %{_sysconfdir}/%{name}/settings.yml %{_localstatedir}/lib/rpm-state/%{name}/settings.yml.orig
fi

exit 0

%post
# Migrate legacy monolithic proxy config
if [ $1 == 2 -a -e %{_localstatedir}/lib/rpm-state/%{name}/settings.yml.orig ]; then
  pushd %{_localstatedir}/lib/rpm-state/%{name} >/dev/null
  if %{homedir}/extra/migrate_settings.rb settings.yml.orig; then
    mv settings.yml %{_sysconfdir}/%{name}
    sed -i '/^---/ a #replace default location of "settings.d"\n:settings_directory: %{_sysconfdir}/%{name}/settings.d\n' \
      %{_sysconfdir}/%{name}/settings.yml
    rm -f settings.yml.orig
    ls *.yml >/dev/null 2>&1 && mv *.yml %{_sysconfdir}/%{name}/settings.d/
  else
    rm -f settings.yml.orig
  fi
  popd >/dev/null
fi

%if 0%{?rhel} == 6
  /sbin/chkconfig --add %{name}
  exit 0
%else
  if [ $1 -eq 1 ]; then
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
  fi
%endif

%preun
if [ $1 -eq 0 ] ; then
  # Package removal, not upgrade
  %if 0%{?rhel} == 6
    /sbin/service %{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
  %else
    /bin/systemctl --no-reload disable foreman-proxy.service >/dev/null 2>&1 || :
    /bin/systemctl stop foreman-proxy.service >/dev/null 2>&1 || :
  %endif
fi

%postun
%if 0%{?rhel} == 6
  if [ $1 -ge 1 ] ; then
    /sbin/service %{name} restart >/dev/null 2>&1
  fi
%else
  /bin/systemctl daemon-reload >/dev/null 2>&1 || :
  if [ $1 -ge 1 ] ; then
    /bin/systemctl try-restart foreman-proxy.service >/dev/null 2>&1 || :
  fi
%endif


%changelog
* Tue Jun 02 2015 Mike McCune <mmccune@redhat.com> 1.7.2.5-1
- Fixes #10116 - BMC is not able to use parameters passed in through body
  (corey@logicminds.biz)
- Fixes #7543 - allow additional rubyipmi connection options to be passed
  through (corey@logicminds.biz)
- Fixes #9852 - REST API violation in BMC smart proxy API     * authentication
  errors now return 401 and proper message (corey@logicminds.biz)
- Fixes #9840 - BMC providers should return 501 error code when they don't
  implement the api call (corey@logicminds.biz)
- Fixes #9711 - bmc module does not full implement its api    * adds additional
  logic around providers    * implements /providers, /providers/installed,
  /host, /    * the / returns a list of resources to use to help the user    *
  catches a case where if the provider is nil, we can default to a provider and
  warn the user    * changes the bmc_setup method to be public instead of
  private.    * refactors the providers_installed? rubyipmi command to
  providers_installed (corey@logicminds.biz)
- Fixes #9710 - add rubyipmi test_connection api call (corey@logicminds.biz)
- Fixes #9709 - allow the bmc module to log all impi calls
  (corey@logicminds.biz)

* Tue Mar 17 2015 Jason Montleon <jmontleo@redhat.com> 1.7.2.4-1
-  add smart_proxy_discovery dependency to rpm spec (jmontleo@redhat.com)
- fixes #8811 - refactor per-module enabling of http(s) to http(s)_rackup
  (shlomi@ben-hanna.com)
- Fixes #8748 - Allow per-module enabling of http(s) (gsutclif@redhat.com)
- fixes #9102 - remove trusted_hosts check from templates module
  (stbenjam@redhat.com)

* Tue Feb 24 2015 Jason Montleon <jmontleo@redhat.com> 1.7.2.3-1
- update foreman-proxy.spec for BZ113410 (jmontleo@redhat.com)
- Fixes #9457 - fixed file permissions of debug script (lzap+git@redhat.com)
- Refs #8710 - moved foreman-debug bits into proxy package
  (lzap+git@redhat.com)

* Tue Feb 17 2015 Jason Montleon <jmontleo@redhat.com> 1.7.2.2-1
- 1191117 - refactored SSL client verification into method
  (lzap+git@redhat.com)

* Tue Jan 27 2015 Jason Montleon <jmontleo@redhat.com> 1.7.2.1-1
- bump version to 1.7.2 (jmontleo@redhat.com)
- Merge remote-tracking branch 'upstream/1.7-stable' into SATELLITE-6.1.0
  (jmontleo@redhat.com)
- Release 1.7.2 (dcleal@redhat.com)
- Fixes #8788 - DHCP not detecting pingable addresses on Windows
  (zjherner@gmail.com)
- Fixes #8853 - Actually redirect stderr to proxy error log
  (math.parent@gmail.com)

* Wed Dec 17 2014 Jason Montleon <jmontleo@redhat.com> 1.7.1.1-1
- update version to 1.7.1 (jmontleo@redhat.com)
- Merge tag '1.7.1' into SATELLITE-6.1.0 (jmontleo@redhat.com)
- Release 1.7.1 (dcleal@redhat.com)
- Fixes #8538 - Fixed ISC DHCP states and duplicities (lzap+git@redhat.com)
- Release 1.7.0 (dcleal@redhat.com)
- fixes #8282: sslv3 is disabled (dmitri@appliedlogic.ca)
- Release 1.7.0-RC2 (dcleal@redhat.com)
- fixes #7197 - add man page for foreman-prepare-realm (stbenjam@redhat.com)
- Fixes #8347 - facts feature should not be enabled by default
  (orabin@redhat.com)
- fixes #8278 - update foreman-prepare-realm for freeipa 4
  (stbenjam@redhat.com)
- Fixes #8320 - shutdown shell provider threading fixed (lzap+git@redhat.com)
- Release 1.7.0-RC1 (dcleal@redhat.com)
- fixes #8300 - set webmock custom HTTP status response correctly
  (dcleal@redhat.com)
- Fixes #8160 - Remove chef related code (mhulan@redhat.com)
- Refs #969 - Proxy-side changes for serving templates from the proxy
  (dtsang@redhat.com)
- fixes #7352 - missing DNS record returns 404 (shlomi@ben-hanna.com)
- Fixes #8006 - added STDOUT proxy log option (lzap+git@redhat.com)

* Fri Dec 05 2014 Jason Montleon <jmontleo@redhat.com> 1.7.0.1-1
- update rel-eng files and sources (jmontleo@redhat.com)
- fixes #8282: sslv3 is disabled (dmitri@appliedlogic.ca)
- fixes #7197 - add man page for foreman-prepare-realm (stbenjam@redhat.com)
- Fixes #8347 - facts feature should not be enabled by default
  (orabin@redhat.com)
- fixes #8278 - update foreman-prepare-realm for freeipa 4
  (stbenjam@redhat.com)
- Refs #8267 - pass template_url in call to foreman (gsutclif@redhat.com)
- Fixes #8320 - shutdown shell provider threading fixed (lzap+git@redhat.com)
- fixes #8300 - set webmock custom HTTP status response correctly
  (dcleal@redhat.com)
- Fixes #8160 - Remove chef related code (mhulan@redhat.com)
- Refs #969 - Proxy-side changes for serving templates from the proxy
  (dtsang@redhat.com)
- fixes #7352 - missing DNS record returns 404 (shlomi@ben-hanna.com)
- Fixes #8006 - added STDOUT proxy log option (lzap+git@redhat.com)
- Bump version to 1.8-develop (dcleal@redhat.com)
- Fixes #7859 - puppetssh run works on Ruby 1.9+ (lzap+git@redhat.com)
- Fixes #7922 - promote uri and http to instance property (slukasik@redhat.com)
- fixes #7660: fixes first bunch of rubocop warnings (dmitri@appliedlogic.ca)
- Fixes #7862 - Upgrade rubocop version (daviddavis@redhat.com)
- Fixes #7860 - added puppetssh_wait option (tom@kuther.net)
- fixes #7822 - forbid HTTPS requests with no client SSL certificate
  (dcleal@redhat.com)
- fixes #7850 - pin mixlib-shellout for Ruby 1.8 compatibility
  (dcleal@redhat.com)
- Fixes #7749 - allow using logger in log_halt helper (mhulan@redhat.com)
- Fixes #7181: added initial support for rubocop (dmitri@appliedlogic.ca)
- fixes #7596 - validate plugin dependencies when loading, various fixes
  (dcleal@redhat.com)
- Fixes #7438: moved facter loading into the facter plugin descriptor
  (dmitri@appliedlogic.ca)
- fixes #7297 - corrected name of DNS namespace in virsh error handlers
  (dcleal@redhat.com)
- fixes #7351: plugins no longer crash smart-proxy if they are missing either
  of rackup paths (dmitri@appliedlogic.ca)
- fixes #7235: dhcp tests are now order-independent (dmitri@appliedlogic.ca)
- fixes #7225: logger is now being correctly initialized during launch
  (dmitri@appliedlogic.ca)
- fixes #7274 - generate date format expectation in tests to handle Ruby/JSON
  differences (dcleal@redhat.com)
- fixes #7240: puppetca now loads correctly if puppet module is disabled
  (dmitri@appliedlogic.ca)
- fixes #7080: symbols are no longer being sorted (dmitri@appliedlogic.ca)
- fixes #7060: puppet gem is no longer required if puppetca is disabled.
  (dmitri@appliedlogic.ca)
- fixes #7062: facts module uses correct path for 'requires'
  (dmitri@appliedlogic.ca)
- fixes #7015 - to_json passes options through correctly, remove array wrapping
  (dcleal@redhat.com)
- Bump version to 1.7-develop (dcleal@redhat.com)
- fixes #6722 - correct require for kerberos utilities (dcleal@redhat.com)
- fixes #6589 - add trusted_hosts check back (dcleal@redhat.com)
- fixes #6956 - rack 1.1 minimum required for Rack::Server#start
  (dcleal@redhat.com)
- fixes #6542 - ship freeipa users script with the smart proxy
  (stbenjam@redhat.com)
- fixes #6522 - move request code out of chef module (mmilata@redhat.com)
- Fixes #6743 - Common code for manage_subnet? in ISC and Native MS
  (aaron@serendipity.cx)
- Fixes #6744 - Avoid nested arrays and extra array copies in the ISC DHCP
  config parser (aaron@serendipity.cx)
- Fixes #6745 - Clean up the params input to the DHCP::Server.addRecord method
  (aaron@serendipity.cx)
- Fixes #6742 - Add a unit test suite for the DHCP API (aaron@serendipity.cx)
- fixes #6908 - update request tests for latest Chef release
  (dcleal@redhat.com)

* Tue Dec 02 2014 Dominic Cleal <dcleal@redhat.com> 1.7.0-1
- Release 1.7.0

* Tue Nov 25 2014 Dominic Cleal <dcleal@redhat.com> 1.7.0-0.2.RC2
- Release 1.7.0-RC2
- refs #7197 - add foreman-prepare-realm man page (stbenjam@redhat.com)

* Tue Nov 11 2014 Dominic Cleal <dcleal@redhat.com> 1.7.0-0.1.RC1
- Release 1.7.0-RC1

* Mon Aug 11 2014 Dominic Cleal <dcleal@redhat.com> - 1.7.0-0.develop
- Bump version to 1.7-develop

* Wed Apr 16 2014 Dominic Cleal <dcleal@redhat.com> - 1.6.0-0.develop
- Bump to version 1.6-develop

* Thu Jan 16 2014 Dominic Cleal <dcleal@redhat.com> - 1.5.0-0.develop
- Bump to version 1.5-develop

* Thu Nov 21 2013 Dominic Cleal <dcleal@redhat.com> - 1.4.0-0.develop
- Bump and change versioning scheme (#3712)
- Ship config.ru for running under Passenger

* Thu Sep 05 2013 Lukas Zapletal <lzap+rpm[@]redhat.com> - 1.3.9999-1
- bump to version 1.3-develop

* Wed Jul 03 2013 Dominic Cleal <dcleal@redhat.com> - 1.2.9999-3
- add rubyipmi dependency for BMC support

* Tue Jun 11 2013 Lukas Zapletal <lzap+rpm[@]redhat.com> - 1.2.9999-2
- fixed service file for systemd
- /etc/sysconfig configuration is no longer in use for systemd

* Thu May 16 2013 Martin Bačovský <mbacovsk@redhat.com> 1.2.9999-1
- added support for building with tito

* Mon Feb 4 2013 shk@redhat.com 1.1-1
- 1.1 final.

* Fri Jan 25 2013 shk@redhat.com 1.1RC3-1
- Updated to RC3

* Wed Jan 09 2013 shk@redhat.com 1.1RC2-1
- Updated to RC2
- Removed net-ping dependency

* Tue Jan 1 2013 shk@redhat.com 1.1RC1-1
- Update to 1.1RC1

* Thu Aug 30 2012 jmontleo@redhat.com 1.0.0-3
- Update to include up to 330dbef353

* Sun Aug 05 2012 jmontleo@redhat.com 1.0.0-2
- Update to pull in fixes

* Mon Jul 23 2012 jmontleo@redhat.com 1.0.0-1
- Update packages for Foreman 1.0 Release.

* Wed Jul 18 2012 jmontleo@redhat.com 1.0.0-0.7
- Updated pacakages for Foreman 1.0 RC5 and Proxy RC2

* Thu Jul 05 2012 jmontleo@redhat.com 1.0.0-0.6
- Fix foreman-release to account for different archs. Pull todays source.

* Wed Jul 04 2012 jmontleo@redhat.com 1.0.0-0.5
- Bump version number for foreman RC3 and build with todays develop branch

* Sun Jul 01 2012 jmontleo@redhat.com 1.0.0-0.4
- Pull todays develop branch

* Fri Jun 29 2012 jmontleo@redhat.com 1.0.0-0.2
- Rebuild with develop branch from today. Hopefully we're really 1.0.0 RC2 this time

* Tue Jun 19 2012 jmontleo@redhat.com 0.5.1-9
- Rebuild with todays develop branch.

* Thu Jun 14 2012 jmontleo@redhat.com 0.5.1-8
- Rebuild with todays develop branch.

* Tue May 08 2012 Jason Montleon <jmontleo@redhat.com> - 0.5.1-1
- update version to match foreman package version

* Wed Dec 28 2011 Ohad Levy <ohadlevy@gmail.com> - 0.3.1
- rebuilt

* Tue Nov 08 2011 Ohad Levy <ohadlevy@gmail.com> - 0.3
- rebuilt

* Wed Sep 28 2011 Ohad Levy <ohadlevy@gmail.com> - 0.3rc2
- rebuilt

* Sat Sep 10 2011 Ohad Levy <ohadlevy@gmail.com> - 0.3rc1
- rebuilt

* Mon Jun 6 2011 Ohad Levy <ohadlevy@gmail.com> - 0.2
- rebuilt

* Thu May 26 2011 ohadlevy@gmail.com - 0.2rc2-2
- rebuilt

* Thu Feb 24 2011 Ohad Levy <ohadlevy@gmail.com> - 0.1.0rc
- new package built with tito

* Wed Jan 26 2011 Lukas Zapletal <lzap+git@redhat.com> - 0.1.0
- new package built with tito
